Elasticsearch7.7 K8S上集群部署升级文档操作手册
(升级需要先停所有产线应用服务、再停原Es中间件服务、备份原ES目录，上传新elasticsearch7.6.tar解压)
###

一、先加载镜像到用户环境
（1）、master节点 elasticsearch7.6.tar 解压目录下操作（解压到产线middleware目录，cd到项目elasticsearch7.6目录）：
docker load -i elasticsearch_prod660-v7.17.4.1.tar 
（2）、备注：需要修改为用户镜像，再push前执行 docker tag registry.edoc2.com:5000/edoc2v5/elasticsearch_prod660-v7.17.4.1 {用户指定的image tag}
默认执行：docker push registry.edoc2.com:5000/edoc2v5/elasticsearch:prod660-v7.17.4.1
（3）、单机第一次部署 standalone-k8s-1.23-middleware-v6.6.tar.xz 已集成，如是升级操作参考如下信息
*******************************************************
如果是升级操作原es6版本停止后做yaml目录备份处理（需要和用户沟通es6升级es7停机排计划,且操作事项如下）
单机：升级执行 docker load -i elasticsearch_prod660-v7.17.4.1.tar 替换 edoc2-es.yaml中的镜像标签 为 registry.edoc2.com:5000/edoc2v5/elasticsearch_prod660-v7.17.4.1 ; 
单机替换edoc2-es.yaml 镜像标签后，直接执行：
chmod -R 777 /home/data/es # 目录存在了，node目录下的node.lock权限问题无法覆盖处理。
kubectl apply -f edoc2-es.yaml
*******************************************************
（4）、集群放开共享存储备份用操作（存储默认路径产研运维定义为 es0的pv：/home/data/es01 es1的pv：/home/data/es02 es2的pv：/home/data/es03）
# vim es0.yaml
  vim es1.yaml
  vim es2.yaml
# 以上三个yaml如果放开共享存储做备份处理需要进行如下放开注释操作：
        volumeMounts:
          #- mountPath: /esbackup               # 需要放开行
          #  name: es-dbbackup-volume           # 需要放开行
        # {....其余内容忽略}
      volumes:
        # {....其余内容忽略}
        #- name: es-dbbackup-volume             # 需要放开行
        #  hostPath:                            # 需要放开行
        # /home/data/esbackup 备份路径必须是共享存储nas路径(共享存储产研运维定义默认为/home/data/esbackup 无特殊用户要求不做挂载路径调整)
        #    path: /home/data/esbackup          # 需要放开行

按esc后输入wq!
保存退出
（5）、修改 registry.edoc2.com:5000/edoc2v5/elasticsearch:prod660-v7.17.4.1 为 {用户指定的image tag}  # 用户无要求忽略
wq!保存退出
# vim es0.yaml
  vim es1.yaml
  vim es2.yaml
修改 registry.edoc2.com:5000/edoc2v5/elasticsearch:prod660-v7.17.4.1 为 {用户指定的image tag}  # 用户无要求忽略
按esc后输入wq!
保存退出



###
二、通过手动脚本启动Elasticsearch集群操作：
# 升级操作原es6版本停止后做yaml目录备份处理（需要和用户沟通es6升级es7停机排计划）
1、vim deploy_es.sh
#!/bin/bash
# 以下信息确认如果ssh免密不满足要求，则需要采用命令行纯手动命令行操作，目录创建纯手动部署模式，见此Rabbitmq-README.md文档三操作。
# 对应你部署环境namesapce命令（必填）
namespace=edoc2

# 部署三节点的k8snode节点主机名 k8s-node01 k8s-node02 k8s-node03 必须替换自己的节点主机名（必填）
WorkNode01=k8s-node01
WorkNode02=k8s-node02
WorkNode03=k8s-node03
SSH_PORT=22

# 写死参数无需修改(存储默认路径产研运维定义为 es0的pv：/home/data/es01 es1的pv：/home/data/es02 es2的pv：/home/data/es03)
pv_yaml="es-pv.yaml"
pvc_yaml="es-pvc.yaml"
# 共享存储默认路径/home/data/esbackup（所有挂载节点相同）

2、执行命令操作：
（1）、source deploy_es.sh start
（2）、source deploy_es.sh stop
（3）、source deploy_es.sh restart


###
三、纯手动执行命令行操作：
# 升级操作原es6版本停止后做yaml目录备份处理（需要和用户沟通es6升级es7停机排计划）
1、准备工作操作命令：
# 存储节点路径创建
（1）、第一个k8s middleware宿主机节点操作执行命令：
mkdir -p /home/data/es01
（2）、第二个k8s middleware宿主机节点操作执行命令：
mkdir -p /home/data/es02
（3）、第三个k8s middleware宿主机节点操作执行命令：
mkdir -p /home/data/es03
# 备份节点路径创建：
1）、第一个k8s middleware宿主机节点操作执行命令：
mkdir -p /home/data/esbackup && mount.nfs -o noac {用户提供的nas地址}:{用户提供的nas共享路径} /home/data/esbackup    
# 建议写入 /etc/fstab  示例：{用户提供的nas地址}:{用户提供的nas共享路径} /home/data/esbackup nfs  defaults,nfsvers=4,_netdev,noac  0  0 
（2）、第二个k8s middleware宿主机节点操作执行命令：
mkdir -p /home/data/esbackup && mount.nfs -o noac {用户提供的nas地址}:{用户提供的nas共享路径} /home/data/esbackup
# 建议写入 /etc/fstab  示例：{用户提供的nas地址}:{用户提供的nas共享路径} /home/data/esbackup nfs  defaults,nfsvers=4,_netdev,noac  0  0 
（3）、第三个k8s middleware宿主机节点操作执行命令：
mkdir -p /home/data/esbackup && mount.nfs -o noac {用户提供的nas地址}:{用户提供的nas共享路径} /home/data/esbackup
# 建议写入 /etc/fstab  示例：{用户提供的nas地址}:{用户提供的nas共享路径} /home/data/esbackup nfs  defaults,nfsvers=4,_netdev,noac  0  0 


2、master01节点操作rabbitmq yaml编排文件：
   替换{需要修改的}
（1）、sed -i "s#namespace: edoc2#namespace {需要修改的}#g" *.yaml && sed -i "s#namespace: edoc2#namespace {需要修改的}#g" *.sh
 (2) 、sed -i "s#edoc2.svc#{新namespace}.svc#g" es-configmap.yaml
（3）、vim es-pv.yaml
# 修改如下信息：
    storage: 250Gi  # 默认250Gi 如需要扩容-修改存储pv大小三处
    path: /home/data/es01
    path: /home/data/es02
    path: /home/data/es03 
    # 根默认/home/data/，一定要修改只需修改 /home/data/根路径   es01 es02 es03禁止修改
wq! 保存退出

3、master01节点操作手动定义打节点标签：
（1）、执行如下操作：
# 定义node宿主机名字
WorkNode01={你环境的中间件第一节点主机名}
WorkNode02={你环境的中间件第二节点主机名}
WorkNode03={你环境的中间件第三节点主机名}
kubectl label nodes $WorkNode01 node.rabbitmq.labels=rabbitmq-node01
kubectl label nodes $WorkNode02 node.rabbitmq.labels=rabbitmq-node02
kubectl label nodes $WorkNode03 node.rabbitmq.labels=rabbitmq-node03
kubectl label nodes $WorkNode01 node.labels.nodelabels=Middleware
kubectl label nodes $WorkNode02 node.labels.nodelabels=Middleware
kubectl label nodes $WorkNode03 node.labels.nodelabels=Middleware

4、master01节点操作，启动rabbitmq集群操作命令：
# 升级操作原es6升级到es7所有节点提前执行如下操作：
中间件es0第一节点：chmod -R 777 /home/data/es01 # 目录存在了，node目录下的node.lock权限问题无法覆盖处理。
中间件es1第二节点：chmod -R 777 /home/data/es02 # 目录存在了，node目录下的node.lock权限问题无法覆盖处理。
中间件es2第三节点：chmod -R 777 /home/data/es03 # 目录存在了，node目录下的node.lock权限问题无法覆盖处理。

（1）、创建StorageClass sc
kubectl apply -f es-sc.yaml
（2）、创建 PV
kubectl apply -f es-pv.yaml
（3）、创建 pvc
kubectl apply -f es-pvc.yaml
（4）、创建es configmap
kubectl apply -f es-configmap.yaml
（5）、启动es服务（3个-es0、es1、es2）
启动命令：
kubectl apply -f es0.yaml
kubectl apply -f es1.yaml
kubectl apply -f es2.yaml
（6）、等待5分钟后确认rabbitmq第一次启动成功命令：
kubectl get pod -n {你自己的namespace} # 默认namespace 为 edoc2
返回信息如下；
NAME                               READY   STATUS    RESTARTS   AGE
es                          1/1     Running   0          1m
es2                         1/1     Running   0          2m
es3                         1/1     Running   0          3m
确认均为 Running切 READY都为 1/1 —— 实际为了考虑es6到es7升级参数保持不变，svc配置 es | es0 | es1 | es2 | es3均可访问。

重要信息：
集群elasticsearch启动完毕！

5、master01节点操作，停止elasticsearch集群操作命令：
（1）、停止elasticsearch集群服务
停止命令：
kubectl delete -f es0.yaml
kubectl delete -f es1.yaml
kubectl delete -f es2.yaml
sleep 30
等待彻底停止
（2）、删除pvc操作命令：
namespace={你自己的namespace命名}
kubectl delete -f es-pvc.yaml
sleep 3
（3）、删除configmap操作命令：
kubectl delete -f es-configmap.yaml
sleep 1
（4）、删除pv操作命令：
kubectl delete -f rabbitmq-pv.yaml
sleep 1
（5）、删除sc操作命令：
kubectl delete -f rabbitmq-sc.yaml

再次启动回到第4步操作！！！
